//testperm.c  ## benes extracted (simplified benes1 + other algo to test)
//   ToDo: buggy! fix problem 
#include <stdlib.h>
#include <stdio.h>
#if __WORDSIZE == 64  /*  /usr/include/limits.h LONG_MAX */
#define Ld_bits 6   /* log-dualis of 64 = 6 */
#else
#define Ld_bits 5
#error wordsize != 64
#endif
#define Bits (1 << Ld_bits)         // 1<<6 == 64
typedef unsigned long  ULong; // 64 bit ULong
typedef struct {
  ULong b1[Ld_bits], b2[Ld_bits]; // butterfly configuration
 } tr_benes;

/* BN(n) = Benes network of stage n = BFLY(n) + iBFLY(n)
 *  hierarchical:
 *   removing the first and last stage of BN(n)
 *   results in two BN(n/2)
 */
/* bit partitioning for bfly init 
 * input: BitsIn = bits at input  of benes network
 *        BitOut = bits at output of benes network
 *        n = number of bits in input and output, n<=Bits
 * output: bitSide = assignment to UNKNOWN=0,LEFT=1,RIGHT=2
 *  taken from book: Y.Hilewitz+R.B.Lee 2008, Fast bit gather, bit scatter and
 *   Chapter 3, Fig. 3.10 cross_partition, config_cross (looks errorous)
 */
int bn_get_position(int bitsIn[Bits], int cur_bit){
  int i; for (i=0;i<Bits;i++) if (bitsIn[i]==cur_bit) return i; return 0; }
char enc64(int i){return ((i<10)?'0'+i:((i-10<='z'-'a')?'a'+i-10:'A'+i-36));} 
void bn_partitioning(int bitsIn[Bits], int bitsOut[Bits], int n, int bitSide[Bits]){
  int i, start_bit, cur_bit, pos_input, pos_output;
  for (i=0;i<n;i++) bitSide[i]=0; /* UNKNOWN side */
  /* unknown which half bits will go */
  printf("DBG bn_pI ");for(i=0;i<n;i++)printf("%c",enc64(bitsIn[i]));printf("\n");
  printf("DBG bn_pO ");for(i=0;i<n;i++)printf("%c",enc64(bitsOut[i]));printf("\n");
  /* for each bit pair one must go to the other half */
  for (i=0;i<n/2;i++) {
//    if (bitsIn[i]>=n){printf("DBG err n=%d i=%d In[i]=%d\n",n,i,bitsIn[i]);exit(1);}
    if (bitSide[/*bitsIn[i]*/i] != 0 /* != UNKNOWN */) continue;
    start_bit= cur_bit= bitsIn[i];
    printf("DBG bn_p i=%d n=%d cur_bit=%d\n", i, n, cur_bit);
    do {
      pos_input= bn_get_position(bitsIn, cur_bit);
      bitSide[/*cur_bit*/pos_input]= 2; /* RIGHT or lower half */
      if(pos_input>=n){printf("DBG err n=%d cur_bit=%d pos_i=%d\n",n,cur_bit,pos_input);exit(1);}
      pos_input=(pos_input + n/2) % n;
      bitSide[/*bitsIn[*/pos_input/*]*/]= 1 ; /* LEFT or upper half */
      pos_output= bn_get_position(bitsOut, bitsIn[pos_input]);
      if(pos_output>=n){printf("DBG err n=%d pos_i=%d pos_o=%d\n",n,pos_input,pos_output);exit(1);}
      pos_output=(pos_output + n/2) % n;
      cur_bit= bitsOut[pos_output/*cur_bit*/];
    } while (cur_bit != start_bit);
    {int j;printf("DBG bn_pS ");for (j=0;j<n;j++) printf("%d",bitSide[j]);printf("\n");}
  }
}  
/* aC stores control bits */
void bn_get_mask(int bitsIn[Bits], int bitsOut[Bits], int n, int aC[12/*2lg(n)*/][Bits]){
  int i, j, lgn, ileft[Bits/2],  oleft[Bits/2] /* high */,
                 iright[Bits/2], oright[Bits/2] /* low */;
  int bitSide[Bits], aC_left[12][Bits], aC_right[12][Bits]; 
  for (lgn=0;lgn<6 && 1<<lgn < n;lgn++); /* (n,lgn)=0,0, 1,0, 2,1, 3,2 */
  if (n==2) { if (bitsIn[0]==bitsOut[0]) { aC[0][0]=0; aC[1][0]=0; /* BFLY+iBFLY */
                                           aC[0][1]=0; aC[1][1]=0; /* +pair */ }   
              else                       { aC[0][0]=0; aC[1][0]=1;
                                           aC[0][1]=0; aC[1][1]=1; }
              return; }
  bn_partitioning(bitsIn, bitsOut,n, bitSide); /* bits auf 2 Haelften verteilen */
  /* split into 2 sub parmutations */
  for (i=0;i<n/2;i++){
    if (bitSide[/*bitsIn[*/i/*]*/] == 2) /* RIGHT = low bits */
         { aC[0][i]=0; ileft[i]= bitsIn[i]; iright[i]= bitsIn[i+n/2]; }
    else { aC[0][i]=1; ileft[i]= bitsIn[i+n/2]; iright[i]= bitsIn[i];     }
    if (bitSide[bitsOut[i]] == 2) /* RIGHT = low bits */
         { aC[2*lgn-1][i]=0; oleft[i]= bitsOut[i]; oright[i]= bitsOut[i+n/2]; }
    else { aC[2*lgn-1][i]=1; oleft[i]= bitsOut[i+n/2]; oright[i]= bitsOut[i];     }
  }
  /* rekursion */
  printf("DBG bn_gmask start recursion %d lgn=%d\n",n/2, lgn);
  bn_get_mask(ileft,  oleft,  n/2, aC_left );
  bn_get_mask(iright, oright, n/2, aC_right);
  printf("DBG bn_gmask end   recursion %d\n",n/2);
  /* compose 2 halfs */
  for (i=1;i<2*lgn-1;i++) {
    for (j=0;j<n/2;j++) aC[i][j    ]=aC_left[ i-1][j];
    for (j=0;j<n/2;j++) aC[i][j+n/2]=aC_right[i-1][j];
    printf("BN%02d ",i);for(j=0;j<n;j++)printf("%d", aC[i][j]);printf("\n");
  }
}  
/* end book stuff */

void gen_benes(tr_benes *bn, int bitsOut[64]){  // ToDo2015: what about odd N ???
  int i2, i3, bitsIn[64], bn_m[12/* 2lg(64)=2*6 */][64];
  for (i2=0;i2<Bits;i2++) bitsIn[i2]=i2;
  for (i3=0;i3<12;i3++)for (i2=0;i2<Bits;i2++) bn_m[i3][i2]=0; /* init */
  bn_get_mask(bitsIn, bitsOut, 64, bn_m); /* n a power of 2 only ??? */
  for (i3=0;i3<6;i3++) {
    bn->b1[5-i3]=0UL;
    for (i2=0;i2<64;i2++)
      bn->b1[5-i3] |= (bn_m[i3][i2]&1)<<i2;
    printf("BN%02d ",5-i3);for(i2=0;i2<Bits;i2++)printf("%d",bn_m[i3][i2]);printf("\n");
  }
  for (i3=0;i3<6;i3++) {
    bn->b2[i3]=0UL;
    for (i2=0;i2<64;i2++)
      bn->b2[i3] |= (bn_m[6+i3][i2]&1)<<i2;
    printf("BN%02d ",i3);for(i2=0;i2<Bits;i2++)printf("%d",bn_m[6+i3][i2]);printf("\n");
  }
  // ToDo: compute Benes-masks from permutations sym.i
}

void random_perm(int tgt[Bits]) {
  int j,q;
  int x;
  for (q = 0; q <= Bits-1; ++q) tgt[q] = q;
  for (q = 1; q <= Bits-1; ++q) {
    j = random() % (q+1);  // 0..q
    x = tgt[q]; tgt[q] = tgt[j]; tgt[j] = x;
  }
}
int main(int an, char *av[]) {
  int i, j, k, a1;
  unsigned long long mtab[6]={
    0x5555555555555555L,
    0x3333333333333333L,
    0x0f0f0f0f0f0f0f0fL,
    0x00ff00ff00ff00ffL,
    0x0000ffff0000ffffL,
    0x00000000ffffffffL
    };
  int p1[Bits], p2[Bits];          // int[64] perm + copy
  tr_benes benes;  // perm_bas.h
  if (an>1) a1=atoi(av[1]); 
  for(i=0;i<64;i++)p1[i]=i;
  if(a1==1){j=p1[ 0]; p1[ 0]=p1[ 3]; p1[ 3]=p1[ 4]; p1[ 4]=j;}
  if(a1==2){j=p1[ 1]; p1[ 1]=p1[ 19]; p1[ 19]=j;}
  if(a1==3)for(i=0;i<64;i++)p1[i]=(i+4)%64; // shift
  if(a1==4)for(i=0;i<64;i++)p1[i]=(i+1)%64; // shift
  if(a1==5)for(i=0;i<64;i++)p1[i]=(i+63)%64; // shift
  if(a1==6)for(i=0;i<64;i++)p1[i]=(i+8)%64; // shift
  if(a1==7)for(i=0;i<64;i++)p1[i]=i^1; // shift
  if(a1==8)for(i=0;i<64;i++)p1[i]=63-i; // inversion
  if(a1>=9){srand(a1);random_perm(p1);} // perm_bas.c p1[i=0..63]=i; + rnd_swaps
  for(i=0;i<64;i++)printf(" %d", (int)p1[i]);printf(" =perm\n");
  for(i=0;i<64;i++)p2[i]=p1[i]; // copy to compare later
  gen_benes(&benes,p1); // perm_bas.c
//  for(i=0;i<6;i++)printf(" %016Lx =benes.b1[%d]\n",benes.b1[i],i);
//  for(i=0;i<6;i++)printf(" %016Lx =benes.b2[%d]\n",benes.b2[i],i);
 // proof:
  for(i=0;i<64;i++)p1[i]=i; // init perm
  for(i=5;i>=0;i--) {  // BFLY
    for (j=0;j<64;j++)
     if ((mtab[i]>>j&1) && (benes.b1[i]>>j&1)) {
//        printf(" exchange %d %d\n",j,j+(1<<i));
        k=p1[j];
          p1[j]=p1[j+(1<<i)];
                   p1[j+(1<<i)]=k;
        
      }
      printf(" %016Lx =benes.b1[%d].%d\n",benes.b1[i],i,1<<i);
//      for(j=0;j<64;j++)printf(" %2d", (int)p1[j]);printf(" =perm\n");

  }
  for(i=0;i<6;i++) {  // iBFLY
    for (j=0;j<64;j++)
     if ((mtab[i]>>j&1) && (benes.b2[i]>>j&1)) {
//        printf(" exchange %d %d\n",j,j+(1<<i));
        k=p1[j];
          p1[j]=p1[j+(1<<i)];
                   p1[j+(1<<i)]=k;
        
      }
      printf(" %016Lx =benes.b2[%d].%d\n",benes.b2[i],i,1<<i);
//      for(j=0;j<64;j++)printf(" %2d", (int)p1[j]);printf(" =perm\n");

  }
  for(i=0;i<64;i++)printf(" %d", (int)p1[i]);printf(" =perm\n");
  for(i=0;i<64 && p2[i]==p1[i];i++); // compare
  if (i==64) printf("OK\n");
  else printf("ERR at pos %d\n",i);
  return 0;
}

/*

2-8
 0 1 8 3 4 5 6 7 2 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29
 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 5
6 57 58 59 60 61 62 63 =perm
 0000000000000000 =benes.b1[5].32
 0000000000000000 =benes.b1[4].16
 0000000000000004 =benes.b1[3].8
 0000000000000000 =benes.b1[2].4
 0000000000000000 =benes.b1[1].2
 0000000000000000 =benes.b1[0].1
 0000000000000000 =benes.b2[0].1
 0000000000000100 =benes.b2[1].2
 0000000000000000 =benes.b2[2].4
 0000000000000004 =benes.b2[3].8
 0000000000000000 =benes.b2[4].16
 0000000000000000 =benes.b2[5].32

2-9
 0 1 9 3 4 5 6 7 8 2 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29
 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 5
6 57 58 59 60 61 62 63 =perm
 0000000000000000 =benes.b1[5].32
 0000000000000000 =benes.b1[4].16
 0000000000000004 =benes.b1[3].8
 0000000000000000 =benes.b1[2].4
 0000000000000200 =benes.b1[1].2
 0000000000000000 =benes.b1[0].1
 0000000000000400 =benes.b2[0].1
 0000000000000200 =benes.b2[1].2
 0000000000000000 =benes.b2[2].4
 0000000000000004 =benes.b2[3].8
 0000000000000000 =benes.b2[4].16
 0000000000000000 =benes.b2[5].32
 0 1 9 3 4 5 6 7 8 2 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29
 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 5
6 57 58 59 60 61 62 63 =perm
OK

1-19
 0 19 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 1 20 21 22 23 24 25 26 27 28 29
 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 5
6 57 58 59 60 61 62 63 =perm
 0000000000000000 =benes.b1[5].32
 exchange 3 19
 0000000000000008 =benes.b1[4].16
 0000000000000000 =benes.b1[3].8
 0000000000000000 =benes.b1[2].4
 0000000000000000 =benes.b1[1].2
 0000000000000000 =benes.b1[0].1
 0000000000000000 =benes.b2[0].1
 exchange 1 3
 0000000000000002 =benes.b2[1].2
 0000000000000000 =benes.b2[2].4
 0000000000000000 =benes.b2[3].8
 exchange 3 19
 0000000000000008 =benes.b2[4].16
 0000000000000000 =benes.b2[5].32
 0 19 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 1 20 21 22 23 24 25 26 27 28 29
 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 5
6 57 58 59 60 61 62 63 =perm
OK



*/
